Loading...
Searching...
No Matches
AngleConstraints.h
Go to the documentation of this file.
//
// Copyright (C) 2024 Niels Maeder and other RDKit contributors
//
// @@ All Rights Reserved @@
// This file is part of the RDKit.
// The contents are covered by the terms of the BSD license
// which is included in the file license.txt, found at the root
// of the RDKit source tree.
//
#include <RDGeneral/export.h>
#ifndef RD_ANGLECONSTRAINTS_H
#define RD_ANGLECONSTRAINTS_H
#include <vector>
#include <iostream>
#include "ForceField.h"
#include "Contrib.h"
namespace ForceFields {
struct AngleConstraintContribsParams {
unsigned int idx1{0}; //!< index of atom1 of the angle constraint
unsigned int idx2{0}; //!< index of atom2 of the angle constraint
unsigned int idx3{0}; //!< index of atom3 of the angle constraint
double minAngle{0.0}; //!< lower bound of the flat bottom potential
double maxAngle{0.0}; //!< upper bound of the flat bottom potential
double forceConstant{1.0}; //!< force constant for angle constraint
AngleConstraintContribsParams(unsigned int idx1, unsigned int idx2,
unsigned int idx3, double minAngle,
double maxAngle, double forceConstant = 1.0)
: idx1(idx1),
idx2(idx2),
idx3(idx3),
minAngle(minAngle),
maxAngle(maxAngle),
forceConstant(forceConstant) {};
};
//! A term to capture all flat bottom angle constraint potentials.
class RDKIT_FORCEFIELD_EXPORT AngleConstraintContribs
: public ForceFieldContrib {
public:
AngleConstraintContribs() = default;
//! Constructor
/*!
\param owner pointer to the owning ForceField
*/
AngleConstraintContribs(ForceField *owner);
~AngleConstraintContribs() override = default;
//! Add a contribution to this contrib collection
/*!
\param idx1 index of atom1 in the ForceField's positions
\param idx2 index of atom2 in the ForceField's positions
\param idx3 index of atom3 in the ForceField's positions
\param minAngle minimum angle
\param maxAngle maximum angle
\param forceConst force Constant
*/
void addContrib(unsigned int idx1, unsigned int idx2, unsigned int idx3,
double minAngleDeg, double maxAngleDeg, double forceConst);
//! Add a contribution to this contrib collection
/*!
\param idx1 index of atom1 in the ForceField's positions
\param idx2 index of atom2 in the ForceField's positions
\param idx3 index of atom3 in the ForceField's positions
\param relative whether to add the provided angle to the current angle
\param minAngle minimum angle
\param maxAngle maximum angle
\param forceConst force Constant
*/
void addContrib(unsigned int idx1, unsigned int idx2, unsigned int idx3,
bool relative, double minAngleDeg, double maxAngleDeg,
double forceConst);
//! return the contribution of this contrib to the energy of a given state
/*!
\param pos positions of the atoms in the current state
*/
double getEnergy(double *pos) const override;
//! calculate the contribution of this contrib to the gradient at a given
/// state
/*!
\param pos positions of the atoms in the current state
\param grad gradients to be adapted
*/
void getGrad(double *pos, double *grad) const override;
//! Copy constructor
AngleConstraintContribs *copy() const override {
return new AngleConstraintContribs(*this);
}
//! Return true if there are no contributions in this contrib
bool empty() const { return d_contribs.empty(); }
//! Get number of contributions in this contrib
unsigned int size() const { return d_contribs.size(); }
private:
std::vector<AngleConstraintContribsParams> d_contribs;
double computeAngleTerm(const double &angle,
const AngleConstraintContribsParams &contrib) const;
};
} // namespace ForceFields
#endif
Contrib.h
ForceField.h
ForceFields::AngleConstraintContribs
A term to capture all flat bottom angle constraint potentials.
Definition AngleConstraints.h:41
ForceFields::AngleConstraintContribs::getEnergy
double getEnergy(double *pos) const override
return the contribution of this contrib to the energy of a given state
ForceFields::AngleConstraintContribs::getGrad
void getGrad(double *pos, double *grad) const override
ForceFields::AngleConstraintContribs::AngleConstraintContribs
AngleConstraintContribs()=default
ForceFields::AngleConstraintContribs::AngleConstraintContribs
AngleConstraintContribs(ForceField *owner)
Constructor.
ForceFields::AngleConstraintContribs::empty
bool empty() const
Return true if there are no contributions in this contrib.
Definition AngleConstraints.h:96
ForceFields::AngleConstraintContribs::~AngleConstraintContribs
~AngleConstraintContribs() override=default
ForceFields::AngleConstraintContribs::addContrib
void addContrib(unsigned int idx1, unsigned int idx2, unsigned int idx3, bool relative, double minAngleDeg, double maxAngleDeg, double forceConst)
Add a contribution to this contrib collection.
ForceFields::AngleConstraintContribs::copy
AngleConstraintContribs * copy() const override
Copy constructor.
Definition AngleConstraints.h:91
ForceFields::AngleConstraintContribs::size
unsigned int size() const
Get number of contributions in this contrib.
Definition AngleConstraints.h:99
ForceFields::AngleConstraintContribs::addContrib
void addContrib(unsigned int idx1, unsigned int idx2, unsigned int idx3, double minAngleDeg, double maxAngleDeg, double forceConst)
Add a contribution to this contrib collection.
ForceFields::ForceFieldContrib
abstract base class for contributions to ForceFields
Definition Contrib.h:18
ForceFields::ForceField
A class to store forcefields and handle minimization.
Definition ForceField.h:79
export.h
RDKIT_FORCEFIELD_EXPORT
#define RDKIT_FORCEFIELD_EXPORT
Definition export.h:185
ForceFields
Definition TorsionAngleContribs.h:21
ForceFields::AngleConstraintContribsParams
Definition AngleConstraints.h:21
ForceFields::AngleConstraintContribsParams::maxAngle
double maxAngle
upper bound of the flat bottom potential
Definition AngleConstraints.h:26
ForceFields::AngleConstraintContribsParams::minAngle
double minAngle
lower bound of the flat bottom potential
Definition AngleConstraints.h:25
ForceFields::AngleConstraintContribsParams::idx3
unsigned int idx3
index of atom3 of the angle constraint
Definition AngleConstraints.h:24
ForceFields::AngleConstraintContribsParams::AngleConstraintContribsParams
AngleConstraintContribsParams(unsigned int idx1, unsigned int idx2, unsigned int idx3, double minAngle, double maxAngle, double forceConstant=1.0)
Definition AngleConstraints.h:28
ForceFields::AngleConstraintContribsParams::idx1
unsigned int idx1
index of atom1 of the angle constraint
Definition AngleConstraints.h:22
ForceFields::AngleConstraintContribsParams::idx2
unsigned int idx2
index of atom2 of the angle constraint
Definition AngleConstraints.h:23
ForceFields::AngleConstraintContribsParams::forceConstant
double forceConstant
force constant for angle constraint
Definition AngleConstraints.h:27